#include "dialogs.h"
#include "sman.h"
#include <sman.rsg>

/*************************************************************
*
* Log level dialog
*
**************************************************************/

CLogLevelDialog::~CLogLevelDialog()
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

CLogLevelDialog::CLogLevelDialog(TUint *logFlags)
{
	localLogFlags = logFlags;
}

TBool CLogLevelDialog::OkToExitL(TInt aButtonId)
{
	CEikCheckBox *controlLogBluejack = STATIC_CAST(CEikCheckBox*, Control(cLogBluejack));
	CEikCheckBox *controlLogOBEX = STATIC_CAST(CEikCheckBox*, Control(cLogOBEX));
	CEikCheckBox *controlLogScanning = STATIC_CAST(CEikCheckBox*, Control(cLogScanning));
	CEikCheckBox *controlLogDecays = STATIC_CAST(CEikCheckBox*, Control(cLogDecays));
	if (aButtonId == EEikBidOk)
	{
		TUint tempFlags;
		
		tempFlags = 0;
		if (controlLogBluejack->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logBluejack);
		if (controlLogOBEX->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logOBEX);
		if (controlLogScanning->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logScanning);
		if (controlLogDecays->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logDecays);
		*localLogFlags = tempFlags;
		return ETrue;
	}
	return ETrue;
} 

void CLogLevelDialog::PreLayoutDynInitL()
{
	CEikCheckBox *controlLogBluejack = STATIC_CAST(CEikCheckBox*, Control(cLogBluejack));
	CEikCheckBox *controlLogOBEX = STATIC_CAST(CEikCheckBox*, Control(cLogOBEX));
	CEikCheckBox *controlLogScanning = STATIC_CAST(CEikCheckBox*, Control(cLogScanning));
	CEikCheckBox *controlLogDecays = STATIC_CAST(CEikCheckBox*, Control(cLogDecays));
	
	if (((*localLogFlags) & CLogger::logBluejack) == CLogger::logBluejack)
		controlLogBluejack->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logOBEX) == CLogger::logOBEX)
		controlLogOBEX->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logScanning) == CLogger::logScanning)
		controlLogScanning->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logDecays) == CLogger::logDecays)
		controlLogDecays->SetState(CEikButtonBase::ESet);
}

/*************************************************************
*
* Bluejack timeout dialogs
*
**************************************************************/

CBluejackTimerDialog::~CBluejackTimerDialog()
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

CBluejackTimerDialog::CBluejackTimerDialog(TInt *noDevicePause, TInt *noDeviceAttempts, TInt *decayTime, TInt *obexTimeout)
{
	localNoDevicePause = noDevicePause;
	localNoDeviceAttempts = noDeviceAttempts;
	localDecayTime = decayTime;
	localObexTimeout = obexTimeout;
}

TBool CBluejackTimerDialog::OkToExitL(TInt aButtonId)
{
	CQikNumberEditor *noDevicePause = STATIC_CAST(CQikNumberEditor*, Control(cNoDevicePause));
	CQikNumberEditor *noDeviceAttempts = STATIC_CAST(CQikNumberEditor*, Control(cNoDeviceAttempts));
	CQikNumberEditor *decayTime = STATIC_CAST(CQikNumberEditor*, Control(cDecayTime));
	CQikNumberEditor *obexTimeout = STATIC_CAST(CQikNumberEditor*, Control(cOBEXTimeout));
	if (aButtonId == EEikBidYes)
	{
		noDevicePause->SetValueL(CONFIG_NO_DEVICE_PAUSE);
		noDeviceAttempts->SetValueL(CONFIG_NO_DEVICE_ATTEMPTS);
		decayTime->SetValueL(CONFIG_DECAY_TIME);
		obexTimeout->SetValueL(CONFIG_OBEX_TIMEOUT);
		return EFalse;
	}
	else if (aButtonId == EEikBidOk)
	{
		*localNoDevicePause = noDevicePause->Value();
		*localNoDeviceAttempts = noDeviceAttempts->Value();
		*localDecayTime = decayTime->Value();
		*localObexTimeout = obexTimeout->Value();
		return ETrue;
	}
	return ETrue;
} 

void CBluejackTimerDialog::PreLayoutDynInitL()
{
	CQikNumberEditor *noDevicePause = STATIC_CAST(CQikNumberEditor*, Control(cNoDevicePause));
	noDevicePause->SetValueL(*localNoDevicePause);
	CQikNumberEditor *noDeviceAttempts = STATIC_CAST(CQikNumberEditor*, Control(cNoDeviceAttempts));
	noDeviceAttempts->SetValueL(*localNoDeviceAttempts);
	CQikNumberEditor *decayTime = STATIC_CAST(CQikNumberEditor*, Control(cDecayTime));
	decayTime->SetValueL(*localDecayTime);
	CQikNumberEditor *obexTimeout = STATIC_CAST(CQikNumberEditor*, Control(cOBEXTimeout));
	obexTimeout->SetValueL(*localObexTimeout);
	
	CEikCaptionedControl *decayTimeControl = Line(cDecayTime);
	decayTimeControl->SetDividerAfter(ETrue);
}

/*************************************************************
*
* Hotkey dialog
*
**************************************************************/

CHotkeyDialog::~CHotkeyDialog()
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

CHotkeyDialog::CHotkeyDialog(TInt *iHotkey)
{
	localiHotkey = iHotkey;
}

TBool CHotkeyDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		// Save the config changes
		CEikChoiceList *myHotkey = STATIC_CAST(CEikChoiceList*, Control(cHotkeyControl));
		*localiHotkey = myHotkey->CurrentItem();

		return ETrue;
	}
	return EFalse;
} 

void CHotkeyDialog::PreLayoutDynInitL()
{
	CEikChoiceList *hotkeyChoiceList;
	hotkeyChoiceList = STATIC_CAST(CEikChoiceList*, Control(cHotkeyControl));
	hotkeyChoiceList->SetArrayL(R_HOTKEY_ARRAY);	
	hotkeyChoiceList->SetCurrentItem(*localiHotkey);
}

/*************************************************************
*
* Shortcut dialog
*
**************************************************************/

CShortcutDialog::CShortcutDialog(CArrayFixFlat<TUid> *shortCut)
{
	tempUid = shortCut;
	// For each app we get from the app server, store its caption and uid
	appListArray = new (ELeave) CDesCArrayFlat(3);
	appListUid = new (ELeave) CArrayFixFlat<TUid>(3);
}

CShortcutDialog::~CShortcutDialog()
{
	delete appListArray;
	delete appListUid;
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

TBool CShortcutDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		if (tempUid != NULL)
		{
			for (int i = 0; i < tempUid->Count(); i++)
			{
				CEikChoiceList *myShortCut = STATIC_CAST(CEikChoiceList*, Control(cShortcut1 + i));
				if (tempUid != NULL)
					tempUid->At(i) = appListUid->At(myShortCut->CurrentItem());
			}
		}
		return ETrue;
	}
	return EFalse;
} 

void CShortcutDialog::PreLayoutDynInitL()
{
	int dump;
	TKeyArrayFix keyArray = TKeyArrayFix(0, ECmpTUint);
	
	populateAppArray();
	if (tempUid != NULL)
	{
		for (int i = 0; i < tempUid->Count(); i++)
		{
			CEikChoiceList *myShortCut = STATIC_CAST(CEikChoiceList*, Control(cShortcut1 + i));
			myShortCut->SetArrayL(appListArray);
			myShortCut->SetArrayExternalOwnership(ETrue);
			if (appListUid->Find(tempUid->At(i), keyArray, dump) == 0)
			{
				myShortCut->SetCurrentItem(dump);
			}
			else
			{
				myShortCut->SetCurrentItem(0);
				tempUid->At(i) = KNullUid;
			}
		}
	}
}

void CShortcutDialog::populateAppArray(void)
{
	// Scan the list of applications registered with the app server
	// For each shortcut uid, set focus to that item

	RApaLsSession mySession;
	TApaAppInfo theAppInfo;
	TApaAppCapabilityBuf aCapabilityBuf;
	TBuf<10> appUid;
	TBuf<1> bSeparator;
	TApaAppCaption aCaption;
	TUid aUid;
	TPtrC currentCaption, temp, temp1;
	TLex lxUid;
	
	mySession.Connect();
	mySession.GetAllApps();
	bSeparator.Append(255);

	// Query the app server
	while (mySession.GetNextApp(theAppInfo) == KErrNone)
	{
		if (mySession.GetAppCapability(aCapabilityBuf, theAppInfo.iUid) == KErrNone)
		{
			// Only scan applications that are not hidden
			if (aCapabilityBuf().iAppIsHidden == EFalse)
			{
				// For each app we get from the app server, store its caption and uid
				aCaption.Copy(theAppInfo.iCaption);
				aCaption.Append(bSeparator);
				appUid.Format(_L("%u"), theAppInfo.iUid);
				aCaption.Append(appUid);
				appListArray->AppendL(aCaption);
			}
		}
	}
	mySession.Close();
	appListArray->Sort();

	// The first item is for unassigning a shortcut
	if (tempUid != NULL)
	{
		aCaption.Format(_L("<unassigned>%c%u"), 255, KNullUid);
		appListArray->InsertL(0, aCaption);
	}

	// After sorting, separate the UIDs out. I'm doing this because I couldn't find a
	// nicer way of linking the UID to the Caption while sorting.
	// The assumption is there is no app with a 0xff char in its caption...pretty safe i
	// think!!
	for (int i = 0; i < appListArray->Count(); i++)
	{		
		// Get app caption & uid
		currentCaption.Set(appListArray->MdcaPoint(i));
		TextUtils::ColumnText(temp, 0, &currentCaption, TChar(255));
		TextUtils::ColumnText(temp1, 1, &currentCaption, TChar(255));
		aCaption.Copy(temp);
		lxUid.Assign(temp1);
		lxUid.Val(aUid.iUid);
		appListUid->AppendL(aUid);
		appListArray->Delete(i);
		appListArray->InsertL(i, aCaption);
	}
}

/*************************************************************
*
* Bluebeam log dialog.
*
**************************************************************/

CBluebeamLogDialog::~CBluebeamLogDialog()
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
	tempUiObj->iFileView->blueBeam->logHelper->logDialog = NULL;
}

void CBluebeamLogDialog::PreLayoutDynInitL()
{
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluebeamLog));
	
	textEditor->CreateScrollBarFrameL();
    textEditor->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
}

TBool CBluebeamLogDialog::OkToExitL(TInt aButtonId)
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
	if (aButtonId == EEikBidYes)
		tempUiObj->iFileView->blueBeam->Cancel();
	return ETrue;
}

/*************************************************************
*
* Bluejack log dialog.
*
**************************************************************/

// This dialog class will notify the scanner object that it has
// been created. The scanner class then knows that it can start
// logging details to this dialog class' text editor.

// At the same time, when this dialog terminates, it will notify
// the scanner class that it is no longer valid.

CBluejackLogDialog::CBluejackLogDialog(CLogger *logObj)
{
	localLogObj = logObj;
}

CBluejackLogDialog::~CBluejackLogDialog()
{
	localLogObj->logDialog = NULL;
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

void CBluejackLogDialog::PostLayoutDynInitL()
{
	localLogObj->logDialog = this;
}

void CBluejackLogDialog::PreLayoutDynInitL()
{
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluejackLog));
	
	textEditor->CreateScrollBarFrameL();
    textEditor->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
	textEditor->SetTextL(localLogObj->logBuffer);
	textEditor->SetCursorPosL(textEditor->TextLength(), 0);
	textEditor = NULL;
}

/*************************************************************
*
* Edit the bluejack vcard
*
**************************************************************/

CBluejackMessageDialog::CBluejackMessageDialog(CScanner *scannerObj)
{
	localScannerObj = scannerObj;
}

CBluejackMessageDialog::~CBluejackMessageDialog()
{
	CSMan2AppUi *tempUiObj = STATIC_CAST(CSMan2AppUi*, CEikonEnv::Static()->EikAppUi());
	tempUiObj->isAppUiBusy = EFalse;
}

void CBluejackMessageDialog::makeVCard(void)
{
	RFile outStream;
	TBuf8<MAX_VCARD_SIZE> vcardBuffer8bit;
	
	vcardBuffer8bit.Copy(currBJackMsg);
	vcardBuffer8bit.Insert(0, _L8("BEGIN:VCARD\r\nVERSION:2.1\r\nN:"));
	vcardBuffer8bit.Append(_L8("\r\nEND:VCARD"));
	if (outStream.Replace(iEikonEnv->Static()->FsSession(), localScannerObj->vCardNames[0], EFileRead) == KErrNone)
	{
		outStream.Write(vcardBuffer8bit);
		outStream.Close();
	}
}

TBool CBluejackMessageDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluejackMessage));
		textEditor->GetText(currBJackMsg);
		makeVCard();
	}
	return ETrue;
}

void CBluejackMessageDialog::PreLayoutDynInitL()
{
	// Read the existing vcard
	
	RFile inStream;
	TBuf8<MAX_VCARD_SIZE> buffer8bit;

	buffer8bit.Copy(_L(""));
	if (inStream.Open(iEikonEnv->Static()->FsSession(), localScannerObj->vCardNames[0], EFileRead) == KErrNone)
	{
		TInt fileSize;
		
		inStream.Size(fileSize);
		if ((fileSize > 1) && (fileSize < MAX_VCARD_SIZE))
			inStream.Read(buffer8bit);
		inStream.Close();
	}
	currBJackMsg.Copy(buffer8bit);
	TInt nameField = currBJackMsg.Find(_L("\r\nN:"));
	if (nameField != KErrNotFound)
	{
		currBJackMsg = currBJackMsg.Mid(nameField + 4, currBJackMsg.Length() - nameField - 4);
		nameField = currBJackMsg.Find(_L("\r\n"));
		if (nameField != KErrNotFound)
			currBJackMsg.SetLength(nameField);
	}
	if (currBJackMsg.Length() > MAX_VCARD_FULLNAME)
		currBJackMsg.SetLength(MAX_VCARD_FULLNAME);
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluejackMessage));
	textEditor->SetTextL(&currBJackMsg);
}
