#include <apgcli.h> 			// RApaLsSession
#include <eikdialg.h>			// CEikDialog
#include <eikappui.h>			// CEikAppUi
#include <eikapp.h>				// CEikApplication
#include <qiknumbereditor.h>	// CQikNumberEditor
#include <eikcapc.h>			// CEikCaptionedControl
#include <eikchkbx.h>			// CEikCheckBox
#include <eikchlst.h>			// CEikChoiceList
#include "bjack.h"
#include "sman.hrh"

#if !defined(__DIALOGS_H__)
#define __DIALOGS_H__

/*************************************************************
*
* Logging level dialog
*
**************************************************************/

class CLogLevelDialog : public CEikDialog
{
public:
	CLogLevelDialog(TUint *logFlags);
	~CLogLevelDialog();
protected:
	TUint *localLogFlags;
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
};

/*************************************************************
*
* Various bluejack timer options dialog
*
**************************************************************/

class CBluejackTimerDialog : public CEikDialog
{
public:
	CBluejackTimerDialog(TInt *noDevicePause, TInt *noDeviceAttempts, TInt *decayTime, TInt *obexTimeout);
	~CBluejackTimerDialog();
protected:
	TInt *localNoDevicePause;
	TInt *localNoDeviceAttempts;
	TInt *localDecayTime;
	TInt *localObexTimeout;
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
};

/*************************************************************
*
* Hotkey dialog
*
**************************************************************/

class CHotkeyDialog : public CEikDialog
{
public:
	CHotkeyDialog(TInt *iHotkey);
	~CHotkeyDialog();
protected:
	TInt *localiHotkey;
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
};

/*************************************************************
*
* Shortcuts dialog
*
**************************************************************/

class CShortcutDialog : public CEikDialog
{
public:
	CShortcutDialog(CArrayFixFlat<TUid> *shortCut);
	~CShortcutDialog();
	CDesCArray *appListArray;
	CArrayFixFlat<TUid> *appListUid;
	void populateAppArray(void);
protected:
	CArrayFixFlat<TUid> *tempUid;
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
};

/*************************************************************
*
* Bluejack log dialog
*
**************************************************************/

class CBluejackLogDialog : public CEikDialog
{
public:
	CBluejackLogDialog(CLogger *logObj);
	~CBluejackLogDialog();
protected:
	CLogger *localLogObj;
	virtual void PostLayoutDynInitL();
	virtual void PreLayoutDynInitL();
};

/*************************************************************
*
* Bluebeam log dialog
*
**************************************************************/

class CBluebeamLogDialog : public CEikDialog
{
public:
	~CBluebeamLogDialog();
protected:
	virtual void PreLayoutDynInitL();
	virtual TBool OkToExitL(TInt aButtonId);
};

/*************************************************************
*
* Class for dialog for editing bluejack vcard
*
**************************************************************/

class CBluejackMessageDialog : public CEikDialog
{
public:
	CBluejackMessageDialog(CScanner *scannerObj);
	~CBluejackMessageDialog();
protected:
	void makeVCard(void);
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
	CScanner *localScannerObj;
	TBuf<MAX_VCARD_SIZE> currBJackMsg;
};

#endif